# CellTracking.py
# By MW, Jun 2013
# GPLv3+
#
# This file defines the features that will be loaded in CellTracking


# /!\ Indentation matters
def get_features(features) :
    """feature definition go in this function
    example: features.new_feature('point', 'telophase', 'T', (0.5, 1, 0.2), 'Marks a telophase', model=None)
    usage: features.new_feature(typ, name, short_name, color, description, model=None)
    - typ in ['point', 'multipoint', 'segment', 'multisegment']
    - name: a string
    - short_name: another string. Will be used on the graphical plot
    - color: a RGB tuple, values between 0 and 1
    - description: description of the feature
    - model: not implemented yet. Will be used to put constraints 
      +between features

    /!\ multi* are not implemented yet, lot of unexpected behavior may happen
    If you need it, please contact the developer.
    """
    
    f1 = features.new_feature('point', 'telophase', 'T', (0.5, 1, 0.2), 'Marks a telophase', model=None)
    f3 = features.new_feature('point', 'NEBD', 'N', (1, 1, 0.2), 'Marks a telophase', model=None)
    f2 = features.new_feature('segment', 'anaphase', 'A', (0.5, 0, 0.2), 'Marks an anaphase', model=None)
    # Setting a few phases (DEBUG)
    #f1.set_point(4)
    #f3.set_point(20)
    #f2.set_segment((40, 60))
